<template>
    <div class="">
            <page-header title="Votre profil"></page-header>
            <div class="row pr-4 pl-4">
          <div class="col-md-3">

            <!-- Profile Image -->
            <div class="card card-primary card-outline ">
              <div class="card-body box-profile">                
                <div class="text-center">
                  <avatar :has-avatar="user.hasAvatar" :file="user.avatar"></avatar>
                </div>
                <h3 class="profile-username text-center">{{user.name}}</h3>

                <p class="text-muted text-center text-uppercase">{{user.role ? user.role.libelle : ''}}</p>

                <ul class="list-group list-group-unbordered mb-3">
                  <li class="list-group-item">
                    <b>Locations</b> <a class="float-right">0</a>
                  </li>
                  <li class="list-group-item">
                    <b>Voitures</b> <a class="float-right">0</a>
                  </li>
                  <li class="list-group-item" style="border-bottom:none">
                    <b>Dépenses</b> <a class="float-right">0</a>
                  </li>
                </ul>

              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->

            <!-- About Me Box -->
            <div class="card card-primary">
              <div class="card-header">
                <h3 class="card-title">A propos de moi</h3>
              </div>
              <!-- /.card-header -->
              <div class="card-body">
                                
                <strong><i class="far fa-file-alt mr-1"></i> description</strong>

                <p class="text-muted ml-3">
                   {{ user.description ? user.description : "Non précisée" }}
                  </p>
                <hr>
                <strong><i class="fas fa-book mr-1"></i> Membre depuis le</strong>

                <p class="text-muted ml-3">
                  {{ user.created_at | toDate}}
                </p>
                <hr>

                <strong><i class="fas fa-clock mr-1"></i>Dernière connexion</strong>

                <p class="text-muted ml-3">
                  <span v-if="user.last_sign_out_at!=null"> {{ user.last_sign_out_at  | toDateTime }}</span>
                  <span v-else>Non précisée</span>
                </p>

              </div>
              <!-- /.card-body -->
            </div>
            <!-- /.card -->
          </div>
          <!-- /.col -->
          <div class="col-md-9">
            <div class="card bg-transparent border-none shadow-none">
              <div class="card-header bg-white p-2 d-flex justify-content-between">
                <ul class="nav nav-pills" style="flex:1">
                  <li class="nav-item"><a class="nav-link active" href="#timeline" data-toggle="tab">Activités</a></li>
                </ul>
                <div class="card-tools mr-2">
                  <div class="btn-group">
                      <button type="button" class="btn btn-secondary btn-toggle" data-toggle="dropdown" aria-expanded="false">
                          <i class="fas fa-cog mr-1"></i> Réglages
                      </button>
                      <div class="dropdown-menu dropdown-menu-right" role="menu" x-placement="bottom-end" style="position: absolute; will-change: transform; top: 0px; left: 0px; transform: translate3d(46px, 19px, 0px);">
                          <a href="#" @click.prevent="changePassword" class="dropdown-item"> <i class="fas fa-lock mr-1"></i> Modifier votre mot de passe</a>
                          <a href="#" @click.prevent="changeInfo" class="dropdown-item"><i class="fas fa-user mr-1"></i>Modifier vos infos personnelles</a>
                      </div>
                  </div>
              </div>
              </div><!-- /.card-header -->
              <div class="card-body" v-show="hasActivity">
                <div class="tab-content">
                  <!-- /.tab-pane -->
                  <div class="tab-pane active" id="timeline">
                    <!-- The timeline -->
                          <vue-timeline-update v-for="(activity,key) in activities" :key="key"
                            :date="new Date(activity.created_at)"
                            :description="activity.as_yourself"
                            :category="activity.log_name"
                            :icon="getIcon(activity)"
                            :title="getTitle(activity)"
                            :color="getColor(activity)"
                          />
                        <infinite-loading @infinite="infiniteHandler">
                          <span slot="no-more">
                           Plus de données  disponible :(
                          </span>
                        </infinite-loading>
                  </div>
                </div>
                <!-- /.tab-content -->
              </div><!-- /.card-body -->
            </div>
            <!-- /.nav-tabs-custom -->
            <div class="no-feed" v-show="!hasActivity  && isLoading">
              <div class="text-center" >
                 <svg class="mt-5" style="margin-top:70px!important" id="Capa_1" enable-background="new 0 0 512 512" height="150" viewBox="0 0 512 512" width="150" xmlns="http://www.w3.org/2000/svg" fill="#c2c5ca2b"><g><g><path d="m460.053 396.359c4.142 0 7.5-3.358 7.5-7.5v-315.698c0-4.142-3.358-7.5-7.5-7.5h-24.825v-25.836c0-4.142-3.358-7.5-7.5-7.5h-24.825v-24.825c0-4.142-3.358-7.5-7.5-7.5h-343.456c-4.142 0-7.5 3.358-7.5 7.5v431.339c0 4.142 3.358 7.5 7.5 7.5h24.825v24.825c0 4.142 3.358 7.5 7.5 7.5h24.825v25.836c0 4.142 3.358 7.5 7.5 7.5h343.455c4.142 0 7.5-3.358 7.5-7.5v-80.643c0-4.142-3.358-7.5-7.5-7.5s-7.5 3.358-7.5 7.5v73.143h-328.454v-18.335h303.63c4.142 0 7.5-3.358 7.5-7.5v-127.653c0-4.142-3.358-7.5-7.5-7.5s-7.5 3.358-7.5 7.5v120.152h-328.456v-17.325h303.63c4.142 0 7.5-3.358 7.5-7.5v-158.222c0-4.142-3.358-7.5-7.5-7.5s-7.5 3.358-7.5 7.5v150.723h-328.455v-416.34h328.455v230.528c0 4.142 3.358 7.5 7.5 7.5s7.5-3.358 7.5-7.5v-198.203h17.325v261.163c0 4.142 3.358 7.5 7.5 7.5s7.5-3.358 7.5-7.5v-227.827h17.325v308.199c.001 4.141 3.359 7.499 7.501 7.499z"/><path d="m198.85 185.289v-139.403c0-4.142-3.358-7.5-7.5-7.5h-101.017c-4.142 0-7.5 3.358-7.5 7.5v139.402c0 4.142 3.358 7.5 7.5 7.5h101.017c4.142.001 7.5-3.357 7.5-7.499zm-15-7.5h-86.017v-124.403h86.016v124.403z"/><path d="m364.516 45.886c0-4.142-3.358-7.5-7.5-7.5h-129.301c-4.142 0-7.5 3.358-7.5 7.5v34.346c0 4.142 3.358 7.5 7.5 7.5h129.301c4.142 0 7.5-3.358 7.5-7.5zm-15 26.846h-114.301v-19.346h114.301z"/><path d="m357.016 109.098h-129.301c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h129.301c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m357.016 141.423h-129.301c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h129.301c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m357.016 177.789h-129.301c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h129.301c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m357.016 214.154h-189.911c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h189.911c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m130.74 214.154h-40.407c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h40.406c4.142 0 7.5-3.358 7.5-7.5s-3.357-7.5-7.499-7.5z"/><path d="m357.016 250.521h-189.911c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h189.911c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m130.74 250.521h-40.407c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h40.406c4.142 0 7.5-3.358 7.5-7.5s-3.357-7.5-7.499-7.5z"/><path d="m357.016 286.886h-189.911c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h189.911c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m130.74 286.886h-40.407c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h40.406c4.142 0 7.5-3.358 7.5-7.5s-3.357-7.5-7.499-7.5z"/><path d="m357.016 323.252h-189.911c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h189.911c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m130.74 323.252h-40.407c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h40.406c4.142 0 7.5-3.358 7.5-7.5s-3.357-7.5-7.499-7.5z"/><path d="m357.016 359.618h-189.911c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h189.911c4.142 0 7.5-3.358 7.5-7.5s-3.358-7.5-7.5-7.5z"/><path d="m130.74 359.618h-40.407c-4.142 0-7.5 3.358-7.5 7.5s3.358 7.5 7.5 7.5h40.406c4.142 0 7.5-3.358 7.5-7.5s-3.357-7.5-7.499-7.5z"/></g></g></svg>
            <p class="text-center mt-4">Aucune <b>activité</b> disponible</p>
         </div>
            </div>
          </div>
          <!-- /.col -->
          <b-modal   ref="inputModalPassword" id="my-modal" title="Modification du mot de passe"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="onSubmit()"
                               @reset.prevent="reset()" 
                               @keydown="form.errors.clear($event.target.name)" 
                               @change="form.errors.clear($event.target.name)">
                        <div class="form-group ">
                            <label class="">Ancien mot de passe</label>
                            <input class="form-control form-control-sm " name="current" v-model="form.current" type="password"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('current')" v-text="form.errors.get('current')"></span>
                        </div>
                        <div class="form-group ">
                            <label class="">Nouveau mot de passe</label>
                            <input class="form-control form-control-sm " name="password" v-model="form.password" type="password"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('password')" v-text="form.errors.get('password')"></span>
                        </div>
                        <div class="form-group ">
                            <label class="">Confirmation du nouveau mot de passe</label>
                            <input class="form-control form-control-sm " name="password_confirmation" v-model="form.password_confirmation" type="password"/>
                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('password_confirmation')" v-text="form.errors.get('password_confirmation')"></span>
                        </div>
                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button type="submit" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : "Modifier" }}</button>
											</div>
               </form>
            </b-modal>
            <b-modal  ref="inputModalInfo" id="my-modal-info" title="Modification des infos personnelles"  :hide-footer="true">
                <form class="" method="PATCH"  @submit.prevent="onSubmitInfo()"
                               @reset.prevent="reset()" 
                               @keydown="formInfo.errors.clear($event.target.name)" 
                               @change="formInfo.errors.clear($event.target.name)">
                        <div class="form-group ">
                            <label class="">Votre nom d'utilisateur</label>
                            <input class="form-control form-control-sm " name="name" v-model="formInfo.name" type="text"/>
                            <span class="m-form__help m--font-danger"  v-if="formInfo.errors.has('name')" v-text="formInfo.errors.get('name')"></span>
                        </div>
                        <div class="form-group ">
                            <label class="">Votre e-mail d'utilisateur</label>
                            <input class="form-control form-control-sm " name="email" v-model="formInfo.email" type="text"/>
                            <span class="m-form__help m--font-danger"  v-if="formInfo.errors.has('email')" v-text="formInfo.errors.get('email')"></span>
                        </div>
                      <div class="form-group ">
                            <label class="">A propos de vous</label>
                            <textarea rows="6" class="form-control form-control-sm " placeholder="Dites quelque chose sur vous..." name="description" v-model="formInfo.description" ></textarea>
                            <span class="m-form__help m--font-danger"  v-if="formInfo.errors.has('description')" v-text="formInfo.errors.get('description')"></span>
                        </div>
                      <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
														<button type="submit" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="formInfo.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : "Modifier" }}</button>
											</div>
               </form>
            </b-modal>
        </div>  
    </div>
</template>

<script>
   import Form from "./../../classes/Form"
   import Avatar from "./../../components/Avatar"
   import Vue from 'vue'
    import Master from "./../Master.vue";
import InfiniteLoading from 'vue-infinite-loading';    
    export default {
      mixins: [Master],
      components:
      {
          Avatar,InfiniteLoading
      },
       data (){
         return {
            isLoading:false,
            page:1,
            per_page:10,
            activities:[],
            user : window.App.user,
            form : new Form({
              "current":"",
              "password":"",
              "password_confirmation":""
            }),
            formAvatar : new Form({
              "fichier":"",
            }),
            formInfo : new Form({
            name:"",
            email:'',
            description:"",
            role_id:[]
           }),
         }

       },
        created()
        {
              axios.get("/api/profil/").then((response) =>
                {
                      if(response.data.success)
                       this.user = response.data.user

                },
                (error) =>
                {
                  this.isLoading = false
                });

                 this.getActivities()
            
        },
        mounted() 

        {
            window.event.$on("new-avatar-event",(avatar)=>
            {
               this.user.avatar = avatar
               $("#user-image-little").find('img').attr('src','/storage/avatars/'+avatar)
               $("#user-image-big").find('img').attr('src','/storage/avatars/'+avatar)
               $("#sidebar-user").find('img').attr('src','/storage/avatars/'+avatar)
            })

        },
        computed:{
               hasActivity()
               {
                 return this.activities.length>0 ? true : false
               }
        },
        methods:{

            onLoadingDone() 
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },
          getActivities()
          {
                this.isLoading = true;
                axios.get("/api/profil/activites").then((response) =>
                {
                       this.activities=response.data.data
                       this.isLoading = false;
                       if(this.pageInit==false)
                        this.pageInit =true


                },
                (error) =>
                {
                  this.isLoading = false
                });
          },
          
          getPosts: function () {
            axios.get('/api/profil/activites').then(response => {
              this.activities = response.data.data;
            });
          },
          infiniteHandler: function ($state) {
            let limit = this.activities.length / 10 + 1;
            axios.get('/api/profil/activites', { params: { page: limit } }).then(response => {
              this.loadMore($state, response);
            });
          },
          loadMore: function ($state, response) {
            if ( response.data.data.length ) {
              this.activities = this.activities.concat(response.data.data);
              setTimeout(() => {
                $state.loaded();
              }, 3000);
              if ( response.data.total == this.activities.length ) {
                $state.complete();
              }
            } else {
              $state.complete();
            }
          },
          getDescription(activite)
          {
              if(activite.log_name=="authentification")
              {
                if(activite.description=="connexion")
                {
                  return "Vous vous êtes connecté à l'application"
                }
                else
                {
                  return "Vous vous êtes déconnecté de l'application"
                }
              }
              else
              {
                if(activite.description=="created")
                {
                  return "Vous avez ajouté une ressource "+activite.log_name
                }
                else if(activite.description=="updated")
                {
              
                   return "Vous avez modifié une ressource "+activite.log_name
                }
                else if(activite.description=="deleted")
                {
                   return "Vous avez supprimé une ressource "+activite.log_name
                }
                else
                {
                   return "Vous avez réalisé une modification"
                }
              }
              
          },
          getColor(activite)
          {
            
              return "red"
          },
          getIcon(activite)
          {
                if(activite.description=="created")
                {
                  return "control_point"
                }
                else if(activite.description=="updated")
                {
                   return "edit"
                }
                else if(activite.description=="deleted")
                {
                   return "delete_forever"
                }
                else if(activite.description=="connexion")
                {
                   return "exit_to_app"
                }
                else if(activite.description=="deconnexion")
                {
                   return "exit_to_app"
                }
                else
                {
                   return "code"
                }
              
          },
          getTitle(activite)
          {
                if(activite.description=="created")
                {
                  return "Ajout d'une ressource"
                }
                else if(activite.description=="updated")
                {
                   return "Modification d'une ressource"
                }
                else if(activite.description=="deleted")
                {
                   return "Suppression"
                }
                else if(activite.description=="connexion")
                {
                   return "Entrée dans l'application"
                }
                else if(activite.description=="deconnexion")
                {
                   return "Sortie de l'application"
                }
                else
                {
                   return "Mouvement non indentifié"
                }
              
          },
          changePassword()
          {
            this.form.errors.clearAll()
            this.$refs['inputModalPassword'].show()
          },
          changeAvatar()
          {
            this.formAvatar.errors.clearAll()
            this.$refs['inputModalAvatar'].show()
          },
          changeInfo()
          {
            this.formInfo.email = this.user.email
            this.formInfo.name = this.user.name
            this.formInfo.description = this.user.description
            this.formInfo.errors.clearAll()
            this.$refs['inputModalInfo'].show()
          },
          //Actualise les données générales
            onSubmitInfo()
           {
                                 this.isLoading = true ;
                    //Requête ajax
                    this.formInfo.patch("/api/profil/info").then((response) =>
                        {
                            if(response.success)
                            {
                              flash("<span>Infos enregistrées <strong>avec succès</strong></span>")
                              this.$refs['inputModalInfo'].hide()
                              if(this.user.name!=response.user.name)
                              {
                                 $("#user-image-little").find('span').text(response.user.name)
                                 $("#user-image-big").find('p').text(response.user.name)
                                 $("#sidebar-user").find('p.pull-left').text(response.user.name)
                              }
                              this.user = response.user

                            }


                            else
                            {
                              this.$refs['inputModalInfo'].hide()
                              flash("<span>Infos  non enregistrées</span>",'error')
                            }
                           this.isLoading = false ;
                           

                        },
                        (error) =>
                        {
                           this.isLoading = false
                        });
           },
          onSubmitAvatar()
           {
           },
          onSubmit()
           {
                    this.isLoading = true ;
                    //Requête ajax
                    this.form.patch("/api/profil/password").then((response) =>
                        {
                            if(response.success)
                            {
                              flash("<span>Mot de passe enregistré <strong>avec succès</strong></span>")
                              this.$refs['inputModalPassword'].hide()
                              this.user = response.user
                            }


                            else
                            {
                              this.$refs['inputModalPassword'].hide()
                              flash("<span>Mot de passe non enregistré</span>",'error')
                            }
                           this.isLoading = false ;
                           

                        },
                        (error) =>
                        {
                           this.isLoading = false
                        });
                },
        }
    }
</script>
<style lang="scss" scoped>
.card-primary:not(.card-outline) > .card-header {
    background-color: #6c757d;
}
.card-primary.card-outline {
    border-top: 3px solid #6c757d;
}
</style>